package mocks

// Code generated by http://github.com/gojuno/minimock (dev). DO NOT EDIT.

//go:generate minimock -i github.com/dmitriygnatenko/internal/interfaces.ArticleTagRepository -o ./mocks/article_tag_repository_minimock.go -n ArticleTagRepositoryMock

import (
	"context"
	"sync"
	mm_atomic "sync/atomic"
	mm_time "time"

	"github.com/gojuno/minimock/v3"
)

// ArticleTagRepositoryMock implements interfaces.ArticleTagRepository
type ArticleTagRepositoryMock struct {
	t minimock.Tester

	funcAdd          func(ctx context.Context, articleID int, tagIDs []int) (err error)
	inspectFuncAdd   func(ctx context.Context, articleID int, tagIDs []int)
	afterAddCounter  uint64
	beforeAddCounter uint64
	AddMock          mArticleTagRepositoryMockAdd

	funcDelete          func(ctx context.Context, articleID int, tagIDs []int) (err error)
	inspectFuncDelete   func(ctx context.Context, articleID int, tagIDs []int)
	afterDeleteCounter  uint64
	beforeDeleteCounter uint64
	DeleteMock          mArticleTagRepositoryMockDelete

	funcDeleteByArticleID          func(ctx context.Context, articleID int) (err error)
	inspectFuncDeleteByArticleID   func(ctx context.Context, articleID int)
	afterDeleteByArticleIDCounter  uint64
	beforeDeleteByArticleIDCounter uint64
	DeleteByArticleIDMock          mArticleTagRepositoryMockDeleteByArticleID
}

// NewArticleTagRepositoryMock returns a mock for interfaces.ArticleTagRepository
func NewArticleTagRepositoryMock(t minimock.Tester) *ArticleTagRepositoryMock {
	m := &ArticleTagRepositoryMock{t: t}
	if controller, ok := t.(minimock.MockController); ok {
		controller.RegisterMocker(m)
	}

	m.AddMock = mArticleTagRepositoryMockAdd{mock: m}
	m.AddMock.callArgs = []*ArticleTagRepositoryMockAddParams{}

	m.DeleteMock = mArticleTagRepositoryMockDelete{mock: m}
	m.DeleteMock.callArgs = []*ArticleTagRepositoryMockDeleteParams{}

	m.DeleteByArticleIDMock = mArticleTagRepositoryMockDeleteByArticleID{mock: m}
	m.DeleteByArticleIDMock.callArgs = []*ArticleTagRepositoryMockDeleteByArticleIDParams{}

	return m
}

type mArticleTagRepositoryMockAdd struct {
	mock               *ArticleTagRepositoryMock
	defaultExpectation *ArticleTagRepositoryMockAddExpectation
	expectations       []*ArticleTagRepositoryMockAddExpectation

	callArgs []*ArticleTagRepositoryMockAddParams
	mutex    sync.RWMutex
}

// ArticleTagRepositoryMockAddExpectation specifies expectation struct of the ArticleTagRepository.Add
type ArticleTagRepositoryMockAddExpectation struct {
	mock    *ArticleTagRepositoryMock
	params  *ArticleTagRepositoryMockAddParams
	results *ArticleTagRepositoryMockAddResults
	Counter uint64
}

// ArticleTagRepositoryMockAddParams contains parameters of the ArticleTagRepository.Add
type ArticleTagRepositoryMockAddParams struct {
	ctx       context.Context
	articleID int
	tagIDs    []int
}

// ArticleTagRepositoryMockAddResults contains results of the ArticleTagRepository.Add
type ArticleTagRepositoryMockAddResults struct {
	err error
}

// Expect sets up expected params for ArticleTagRepository.Add
func (mmAdd *mArticleTagRepositoryMockAdd) Expect(ctx context.Context, articleID int, tagIDs []int) *mArticleTagRepositoryMockAdd {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("ArticleTagRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &ArticleTagRepositoryMockAddExpectation{}
	}

	mmAdd.defaultExpectation.params = &ArticleTagRepositoryMockAddParams{ctx, articleID, tagIDs}
	for _, e := range mmAdd.expectations {
		if minimock.Equal(e.params, mmAdd.defaultExpectation.params) {
			mmAdd.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmAdd.defaultExpectation.params)
		}
	}

	return mmAdd
}

// Inspect accepts an inspector function that has same arguments as the ArticleTagRepository.Add
func (mmAdd *mArticleTagRepositoryMockAdd) Inspect(f func(ctx context.Context, articleID int, tagIDs []int)) *mArticleTagRepositoryMockAdd {
	if mmAdd.mock.inspectFuncAdd != nil {
		mmAdd.mock.t.Fatalf("Inspect function is already set for ArticleTagRepositoryMock.Add")
	}

	mmAdd.mock.inspectFuncAdd = f

	return mmAdd
}

// Return sets up results that will be returned by ArticleTagRepository.Add
func (mmAdd *mArticleTagRepositoryMockAdd) Return(err error) *ArticleTagRepositoryMock {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("ArticleTagRepositoryMock.Add mock is already set by Set")
	}

	if mmAdd.defaultExpectation == nil {
		mmAdd.defaultExpectation = &ArticleTagRepositoryMockAddExpectation{mock: mmAdd.mock}
	}
	mmAdd.defaultExpectation.results = &ArticleTagRepositoryMockAddResults{err}
	return mmAdd.mock
}

// Set uses given function f to mock the ArticleTagRepository.Add method
func (mmAdd *mArticleTagRepositoryMockAdd) Set(f func(ctx context.Context, articleID int, tagIDs []int) (err error)) *ArticleTagRepositoryMock {
	if mmAdd.defaultExpectation != nil {
		mmAdd.mock.t.Fatalf("Default expectation is already set for the ArticleTagRepository.Add method")
	}

	if len(mmAdd.expectations) > 0 {
		mmAdd.mock.t.Fatalf("Some expectations are already set for the ArticleTagRepository.Add method")
	}

	mmAdd.mock.funcAdd = f
	return mmAdd.mock
}

// When sets expectation for the ArticleTagRepository.Add which will trigger the result defined by the following
// Then helper
func (mmAdd *mArticleTagRepositoryMockAdd) When(ctx context.Context, articleID int, tagIDs []int) *ArticleTagRepositoryMockAddExpectation {
	if mmAdd.mock.funcAdd != nil {
		mmAdd.mock.t.Fatalf("ArticleTagRepositoryMock.Add mock is already set by Set")
	}

	expectation := &ArticleTagRepositoryMockAddExpectation{
		mock:   mmAdd.mock,
		params: &ArticleTagRepositoryMockAddParams{ctx, articleID, tagIDs},
	}
	mmAdd.expectations = append(mmAdd.expectations, expectation)
	return expectation
}

// Then sets up ArticleTagRepository.Add return parameters for the expectation previously defined by the When method
func (e *ArticleTagRepositoryMockAddExpectation) Then(err error) *ArticleTagRepositoryMock {
	e.results = &ArticleTagRepositoryMockAddResults{err}
	return e.mock
}

// Add implements interfaces.ArticleTagRepository
func (mmAdd *ArticleTagRepositoryMock) Add(ctx context.Context, articleID int, tagIDs []int) (err error) {
	mm_atomic.AddUint64(&mmAdd.beforeAddCounter, 1)
	defer mm_atomic.AddUint64(&mmAdd.afterAddCounter, 1)

	if mmAdd.inspectFuncAdd != nil {
		mmAdd.inspectFuncAdd(ctx, articleID, tagIDs)
	}

	mm_params := &ArticleTagRepositoryMockAddParams{ctx, articleID, tagIDs}

	// Record call args
	mmAdd.AddMock.mutex.Lock()
	mmAdd.AddMock.callArgs = append(mmAdd.AddMock.callArgs, mm_params)
	mmAdd.AddMock.mutex.Unlock()

	for _, e := range mmAdd.AddMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmAdd.AddMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmAdd.AddMock.defaultExpectation.Counter, 1)
		mm_want := mmAdd.AddMock.defaultExpectation.params
		mm_got := ArticleTagRepositoryMockAddParams{ctx, articleID, tagIDs}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmAdd.t.Errorf("ArticleTagRepositoryMock.Add got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmAdd.AddMock.defaultExpectation.results
		if mm_results == nil {
			mmAdd.t.Fatal("No results are set for the ArticleTagRepositoryMock.Add")
		}
		return (*mm_results).err
	}
	if mmAdd.funcAdd != nil {
		return mmAdd.funcAdd(ctx, articleID, tagIDs)
	}
	mmAdd.t.Fatalf("Unexpected call to ArticleTagRepositoryMock.Add. %v %v %v", ctx, articleID, tagIDs)
	return
}

// AddAfterCounter returns a count of finished ArticleTagRepositoryMock.Add invocations
func (mmAdd *ArticleTagRepositoryMock) AddAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.afterAddCounter)
}

// AddBeforeCounter returns a count of ArticleTagRepositoryMock.Add invocations
func (mmAdd *ArticleTagRepositoryMock) AddBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmAdd.beforeAddCounter)
}

// Calls returns a list of arguments used in each call to ArticleTagRepositoryMock.Add.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmAdd *mArticleTagRepositoryMockAdd) Calls() []*ArticleTagRepositoryMockAddParams {
	mmAdd.mutex.RLock()

	argCopy := make([]*ArticleTagRepositoryMockAddParams, len(mmAdd.callArgs))
	copy(argCopy, mmAdd.callArgs)

	mmAdd.mutex.RUnlock()

	return argCopy
}

// MinimockAddDone returns true if the count of the Add invocations corresponds
// the number of defined expectations
func (m *ArticleTagRepositoryMock) MinimockAddDone() bool {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		return false
	}
	return true
}

// MinimockAddInspect logs each unmet expectation
func (m *ArticleTagRepositoryMock) MinimockAddInspect() {
	for _, e := range m.AddMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to ArticleTagRepositoryMock.Add with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.AddMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		if m.AddMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to ArticleTagRepositoryMock.Add")
		} else {
			m.t.Errorf("Expected call to ArticleTagRepositoryMock.Add with params: %#v", *m.AddMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcAdd != nil && mm_atomic.LoadUint64(&m.afterAddCounter) < 1 {
		m.t.Error("Expected call to ArticleTagRepositoryMock.Add")
	}
}

type mArticleTagRepositoryMockDelete struct {
	mock               *ArticleTagRepositoryMock
	defaultExpectation *ArticleTagRepositoryMockDeleteExpectation
	expectations       []*ArticleTagRepositoryMockDeleteExpectation

	callArgs []*ArticleTagRepositoryMockDeleteParams
	mutex    sync.RWMutex
}

// ArticleTagRepositoryMockDeleteExpectation specifies expectation struct of the ArticleTagRepository.Delete
type ArticleTagRepositoryMockDeleteExpectation struct {
	mock    *ArticleTagRepositoryMock
	params  *ArticleTagRepositoryMockDeleteParams
	results *ArticleTagRepositoryMockDeleteResults
	Counter uint64
}

// ArticleTagRepositoryMockDeleteParams contains parameters of the ArticleTagRepository.Delete
type ArticleTagRepositoryMockDeleteParams struct {
	ctx       context.Context
	articleID int
	tagIDs    []int
}

// ArticleTagRepositoryMockDeleteResults contains results of the ArticleTagRepository.Delete
type ArticleTagRepositoryMockDeleteResults struct {
	err error
}

// Expect sets up expected params for ArticleTagRepository.Delete
func (mmDelete *mArticleTagRepositoryMockDelete) Expect(ctx context.Context, articleID int, tagIDs []int) *mArticleTagRepositoryMockDelete {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("ArticleTagRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &ArticleTagRepositoryMockDeleteExpectation{}
	}

	mmDelete.defaultExpectation.params = &ArticleTagRepositoryMockDeleteParams{ctx, articleID, tagIDs}
	for _, e := range mmDelete.expectations {
		if minimock.Equal(e.params, mmDelete.defaultExpectation.params) {
			mmDelete.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmDelete.defaultExpectation.params)
		}
	}

	return mmDelete
}

// Inspect accepts an inspector function that has same arguments as the ArticleTagRepository.Delete
func (mmDelete *mArticleTagRepositoryMockDelete) Inspect(f func(ctx context.Context, articleID int, tagIDs []int)) *mArticleTagRepositoryMockDelete {
	if mmDelete.mock.inspectFuncDelete != nil {
		mmDelete.mock.t.Fatalf("Inspect function is already set for ArticleTagRepositoryMock.Delete")
	}

	mmDelete.mock.inspectFuncDelete = f

	return mmDelete
}

// Return sets up results that will be returned by ArticleTagRepository.Delete
func (mmDelete *mArticleTagRepositoryMockDelete) Return(err error) *ArticleTagRepositoryMock {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("ArticleTagRepositoryMock.Delete mock is already set by Set")
	}

	if mmDelete.defaultExpectation == nil {
		mmDelete.defaultExpectation = &ArticleTagRepositoryMockDeleteExpectation{mock: mmDelete.mock}
	}
	mmDelete.defaultExpectation.results = &ArticleTagRepositoryMockDeleteResults{err}
	return mmDelete.mock
}

// Set uses given function f to mock the ArticleTagRepository.Delete method
func (mmDelete *mArticleTagRepositoryMockDelete) Set(f func(ctx context.Context, articleID int, tagIDs []int) (err error)) *ArticleTagRepositoryMock {
	if mmDelete.defaultExpectation != nil {
		mmDelete.mock.t.Fatalf("Default expectation is already set for the ArticleTagRepository.Delete method")
	}

	if len(mmDelete.expectations) > 0 {
		mmDelete.mock.t.Fatalf("Some expectations are already set for the ArticleTagRepository.Delete method")
	}

	mmDelete.mock.funcDelete = f
	return mmDelete.mock
}

// When sets expectation for the ArticleTagRepository.Delete which will trigger the result defined by the following
// Then helper
func (mmDelete *mArticleTagRepositoryMockDelete) When(ctx context.Context, articleID int, tagIDs []int) *ArticleTagRepositoryMockDeleteExpectation {
	if mmDelete.mock.funcDelete != nil {
		mmDelete.mock.t.Fatalf("ArticleTagRepositoryMock.Delete mock is already set by Set")
	}

	expectation := &ArticleTagRepositoryMockDeleteExpectation{
		mock:   mmDelete.mock,
		params: &ArticleTagRepositoryMockDeleteParams{ctx, articleID, tagIDs},
	}
	mmDelete.expectations = append(mmDelete.expectations, expectation)
	return expectation
}

// Then sets up ArticleTagRepository.Delete return parameters for the expectation previously defined by the When method
func (e *ArticleTagRepositoryMockDeleteExpectation) Then(err error) *ArticleTagRepositoryMock {
	e.results = &ArticleTagRepositoryMockDeleteResults{err}
	return e.mock
}

// Delete implements interfaces.ArticleTagRepository
func (mmDelete *ArticleTagRepositoryMock) Delete(ctx context.Context, articleID int, tagIDs []int) (err error) {
	mm_atomic.AddUint64(&mmDelete.beforeDeleteCounter, 1)
	defer mm_atomic.AddUint64(&mmDelete.afterDeleteCounter, 1)

	if mmDelete.inspectFuncDelete != nil {
		mmDelete.inspectFuncDelete(ctx, articleID, tagIDs)
	}

	mm_params := &ArticleTagRepositoryMockDeleteParams{ctx, articleID, tagIDs}

	// Record call args
	mmDelete.DeleteMock.mutex.Lock()
	mmDelete.DeleteMock.callArgs = append(mmDelete.DeleteMock.callArgs, mm_params)
	mmDelete.DeleteMock.mutex.Unlock()

	for _, e := range mmDelete.DeleteMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmDelete.DeleteMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmDelete.DeleteMock.defaultExpectation.Counter, 1)
		mm_want := mmDelete.DeleteMock.defaultExpectation.params
		mm_got := ArticleTagRepositoryMockDeleteParams{ctx, articleID, tagIDs}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmDelete.t.Errorf("ArticleTagRepositoryMock.Delete got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmDelete.DeleteMock.defaultExpectation.results
		if mm_results == nil {
			mmDelete.t.Fatal("No results are set for the ArticleTagRepositoryMock.Delete")
		}
		return (*mm_results).err
	}
	if mmDelete.funcDelete != nil {
		return mmDelete.funcDelete(ctx, articleID, tagIDs)
	}
	mmDelete.t.Fatalf("Unexpected call to ArticleTagRepositoryMock.Delete. %v %v %v", ctx, articleID, tagIDs)
	return
}

// DeleteAfterCounter returns a count of finished ArticleTagRepositoryMock.Delete invocations
func (mmDelete *ArticleTagRepositoryMock) DeleteAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.afterDeleteCounter)
}

// DeleteBeforeCounter returns a count of ArticleTagRepositoryMock.Delete invocations
func (mmDelete *ArticleTagRepositoryMock) DeleteBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDelete.beforeDeleteCounter)
}

// Calls returns a list of arguments used in each call to ArticleTagRepositoryMock.Delete.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmDelete *mArticleTagRepositoryMockDelete) Calls() []*ArticleTagRepositoryMockDeleteParams {
	mmDelete.mutex.RLock()

	argCopy := make([]*ArticleTagRepositoryMockDeleteParams, len(mmDelete.callArgs))
	copy(argCopy, mmDelete.callArgs)

	mmDelete.mutex.RUnlock()

	return argCopy
}

// MinimockDeleteDone returns true if the count of the Delete invocations corresponds
// the number of defined expectations
func (m *ArticleTagRepositoryMock) MinimockDeleteDone() bool {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		return false
	}
	return true
}

// MinimockDeleteInspect logs each unmet expectation
func (m *ArticleTagRepositoryMock) MinimockDeleteInspect() {
	for _, e := range m.DeleteMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to ArticleTagRepositoryMock.Delete with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		if m.DeleteMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to ArticleTagRepositoryMock.Delete")
		} else {
			m.t.Errorf("Expected call to ArticleTagRepositoryMock.Delete with params: %#v", *m.DeleteMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDelete != nil && mm_atomic.LoadUint64(&m.afterDeleteCounter) < 1 {
		m.t.Error("Expected call to ArticleTagRepositoryMock.Delete")
	}
}

type mArticleTagRepositoryMockDeleteByArticleID struct {
	mock               *ArticleTagRepositoryMock
	defaultExpectation *ArticleTagRepositoryMockDeleteByArticleIDExpectation
	expectations       []*ArticleTagRepositoryMockDeleteByArticleIDExpectation

	callArgs []*ArticleTagRepositoryMockDeleteByArticleIDParams
	mutex    sync.RWMutex
}

// ArticleTagRepositoryMockDeleteByArticleIDExpectation specifies expectation struct of the ArticleTagRepository.DeleteByArticleID
type ArticleTagRepositoryMockDeleteByArticleIDExpectation struct {
	mock    *ArticleTagRepositoryMock
	params  *ArticleTagRepositoryMockDeleteByArticleIDParams
	results *ArticleTagRepositoryMockDeleteByArticleIDResults
	Counter uint64
}

// ArticleTagRepositoryMockDeleteByArticleIDParams contains parameters of the ArticleTagRepository.DeleteByArticleID
type ArticleTagRepositoryMockDeleteByArticleIDParams struct {
	ctx       context.Context
	articleID int
}

// ArticleTagRepositoryMockDeleteByArticleIDResults contains results of the ArticleTagRepository.DeleteByArticleID
type ArticleTagRepositoryMockDeleteByArticleIDResults struct {
	err error
}

// Expect sets up expected params for ArticleTagRepository.DeleteByArticleID
func (mmDeleteByArticleID *mArticleTagRepositoryMockDeleteByArticleID) Expect(ctx context.Context, articleID int) *mArticleTagRepositoryMockDeleteByArticleID {
	if mmDeleteByArticleID.mock.funcDeleteByArticleID != nil {
		mmDeleteByArticleID.mock.t.Fatalf("ArticleTagRepositoryMock.DeleteByArticleID mock is already set by Set")
	}

	if mmDeleteByArticleID.defaultExpectation == nil {
		mmDeleteByArticleID.defaultExpectation = &ArticleTagRepositoryMockDeleteByArticleIDExpectation{}
	}

	mmDeleteByArticleID.defaultExpectation.params = &ArticleTagRepositoryMockDeleteByArticleIDParams{ctx, articleID}
	for _, e := range mmDeleteByArticleID.expectations {
		if minimock.Equal(e.params, mmDeleteByArticleID.defaultExpectation.params) {
			mmDeleteByArticleID.mock.t.Fatalf("Expectation set by When has same params: %#v", *mmDeleteByArticleID.defaultExpectation.params)
		}
	}

	return mmDeleteByArticleID
}

// Inspect accepts an inspector function that has same arguments as the ArticleTagRepository.DeleteByArticleID
func (mmDeleteByArticleID *mArticleTagRepositoryMockDeleteByArticleID) Inspect(f func(ctx context.Context, articleID int)) *mArticleTagRepositoryMockDeleteByArticleID {
	if mmDeleteByArticleID.mock.inspectFuncDeleteByArticleID != nil {
		mmDeleteByArticleID.mock.t.Fatalf("Inspect function is already set for ArticleTagRepositoryMock.DeleteByArticleID")
	}

	mmDeleteByArticleID.mock.inspectFuncDeleteByArticleID = f

	return mmDeleteByArticleID
}

// Return sets up results that will be returned by ArticleTagRepository.DeleteByArticleID
func (mmDeleteByArticleID *mArticleTagRepositoryMockDeleteByArticleID) Return(err error) *ArticleTagRepositoryMock {
	if mmDeleteByArticleID.mock.funcDeleteByArticleID != nil {
		mmDeleteByArticleID.mock.t.Fatalf("ArticleTagRepositoryMock.DeleteByArticleID mock is already set by Set")
	}

	if mmDeleteByArticleID.defaultExpectation == nil {
		mmDeleteByArticleID.defaultExpectation = &ArticleTagRepositoryMockDeleteByArticleIDExpectation{mock: mmDeleteByArticleID.mock}
	}
	mmDeleteByArticleID.defaultExpectation.results = &ArticleTagRepositoryMockDeleteByArticleIDResults{err}
	return mmDeleteByArticleID.mock
}

// Set uses given function f to mock the ArticleTagRepository.DeleteByArticleID method
func (mmDeleteByArticleID *mArticleTagRepositoryMockDeleteByArticleID) Set(f func(ctx context.Context, articleID int) (err error)) *ArticleTagRepositoryMock {
	if mmDeleteByArticleID.defaultExpectation != nil {
		mmDeleteByArticleID.mock.t.Fatalf("Default expectation is already set for the ArticleTagRepository.DeleteByArticleID method")
	}

	if len(mmDeleteByArticleID.expectations) > 0 {
		mmDeleteByArticleID.mock.t.Fatalf("Some expectations are already set for the ArticleTagRepository.DeleteByArticleID method")
	}

	mmDeleteByArticleID.mock.funcDeleteByArticleID = f
	return mmDeleteByArticleID.mock
}

// When sets expectation for the ArticleTagRepository.DeleteByArticleID which will trigger the result defined by the following
// Then helper
func (mmDeleteByArticleID *mArticleTagRepositoryMockDeleteByArticleID) When(ctx context.Context, articleID int) *ArticleTagRepositoryMockDeleteByArticleIDExpectation {
	if mmDeleteByArticleID.mock.funcDeleteByArticleID != nil {
		mmDeleteByArticleID.mock.t.Fatalf("ArticleTagRepositoryMock.DeleteByArticleID mock is already set by Set")
	}

	expectation := &ArticleTagRepositoryMockDeleteByArticleIDExpectation{
		mock:   mmDeleteByArticleID.mock,
		params: &ArticleTagRepositoryMockDeleteByArticleIDParams{ctx, articleID},
	}
	mmDeleteByArticleID.expectations = append(mmDeleteByArticleID.expectations, expectation)
	return expectation
}

// Then sets up ArticleTagRepository.DeleteByArticleID return parameters for the expectation previously defined by the When method
func (e *ArticleTagRepositoryMockDeleteByArticleIDExpectation) Then(err error) *ArticleTagRepositoryMock {
	e.results = &ArticleTagRepositoryMockDeleteByArticleIDResults{err}
	return e.mock
}

// DeleteByArticleID implements interfaces.ArticleTagRepository
func (mmDeleteByArticleID *ArticleTagRepositoryMock) DeleteByArticleID(ctx context.Context, articleID int) (err error) {
	mm_atomic.AddUint64(&mmDeleteByArticleID.beforeDeleteByArticleIDCounter, 1)
	defer mm_atomic.AddUint64(&mmDeleteByArticleID.afterDeleteByArticleIDCounter, 1)

	if mmDeleteByArticleID.inspectFuncDeleteByArticleID != nil {
		mmDeleteByArticleID.inspectFuncDeleteByArticleID(ctx, articleID)
	}

	mm_params := &ArticleTagRepositoryMockDeleteByArticleIDParams{ctx, articleID}

	// Record call args
	mmDeleteByArticleID.DeleteByArticleIDMock.mutex.Lock()
	mmDeleteByArticleID.DeleteByArticleIDMock.callArgs = append(mmDeleteByArticleID.DeleteByArticleIDMock.callArgs, mm_params)
	mmDeleteByArticleID.DeleteByArticleIDMock.mutex.Unlock()

	for _, e := range mmDeleteByArticleID.DeleteByArticleIDMock.expectations {
		if minimock.Equal(e.params, mm_params) {
			mm_atomic.AddUint64(&e.Counter, 1)
			return e.results.err
		}
	}

	if mmDeleteByArticleID.DeleteByArticleIDMock.defaultExpectation != nil {
		mm_atomic.AddUint64(&mmDeleteByArticleID.DeleteByArticleIDMock.defaultExpectation.Counter, 1)
		mm_want := mmDeleteByArticleID.DeleteByArticleIDMock.defaultExpectation.params
		mm_got := ArticleTagRepositoryMockDeleteByArticleIDParams{ctx, articleID}
		if mm_want != nil && !minimock.Equal(*mm_want, mm_got) {
			mmDeleteByArticleID.t.Errorf("ArticleTagRepositoryMock.DeleteByArticleID got unexpected parameters, want: %#v, got: %#v%s\n", *mm_want, mm_got, minimock.Diff(*mm_want, mm_got))
		}

		mm_results := mmDeleteByArticleID.DeleteByArticleIDMock.defaultExpectation.results
		if mm_results == nil {
			mmDeleteByArticleID.t.Fatal("No results are set for the ArticleTagRepositoryMock.DeleteByArticleID")
		}
		return (*mm_results).err
	}
	if mmDeleteByArticleID.funcDeleteByArticleID != nil {
		return mmDeleteByArticleID.funcDeleteByArticleID(ctx, articleID)
	}
	mmDeleteByArticleID.t.Fatalf("Unexpected call to ArticleTagRepositoryMock.DeleteByArticleID. %v %v", ctx, articleID)
	return
}

// DeleteByArticleIDAfterCounter returns a count of finished ArticleTagRepositoryMock.DeleteByArticleID invocations
func (mmDeleteByArticleID *ArticleTagRepositoryMock) DeleteByArticleIDAfterCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDeleteByArticleID.afterDeleteByArticleIDCounter)
}

// DeleteByArticleIDBeforeCounter returns a count of ArticleTagRepositoryMock.DeleteByArticleID invocations
func (mmDeleteByArticleID *ArticleTagRepositoryMock) DeleteByArticleIDBeforeCounter() uint64 {
	return mm_atomic.LoadUint64(&mmDeleteByArticleID.beforeDeleteByArticleIDCounter)
}

// Calls returns a list of arguments used in each call to ArticleTagRepositoryMock.DeleteByArticleID.
// The list is in the same order as the calls were made (i.e. recent calls have a higher index)
func (mmDeleteByArticleID *mArticleTagRepositoryMockDeleteByArticleID) Calls() []*ArticleTagRepositoryMockDeleteByArticleIDParams {
	mmDeleteByArticleID.mutex.RLock()

	argCopy := make([]*ArticleTagRepositoryMockDeleteByArticleIDParams, len(mmDeleteByArticleID.callArgs))
	copy(argCopy, mmDeleteByArticleID.callArgs)

	mmDeleteByArticleID.mutex.RUnlock()

	return argCopy
}

// MinimockDeleteByArticleIDDone returns true if the count of the DeleteByArticleID invocations corresponds
// the number of defined expectations
func (m *ArticleTagRepositoryMock) MinimockDeleteByArticleIDDone() bool {
	for _, e := range m.DeleteByArticleIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			return false
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteByArticleIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteByArticleIDCounter) < 1 {
		return false
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDeleteByArticleID != nil && mm_atomic.LoadUint64(&m.afterDeleteByArticleIDCounter) < 1 {
		return false
	}
	return true
}

// MinimockDeleteByArticleIDInspect logs each unmet expectation
func (m *ArticleTagRepositoryMock) MinimockDeleteByArticleIDInspect() {
	for _, e := range m.DeleteByArticleIDMock.expectations {
		if mm_atomic.LoadUint64(&e.Counter) < 1 {
			m.t.Errorf("Expected call to ArticleTagRepositoryMock.DeleteByArticleID with params: %#v", *e.params)
		}
	}

	// if default expectation was set then invocations count should be greater than zero
	if m.DeleteByArticleIDMock.defaultExpectation != nil && mm_atomic.LoadUint64(&m.afterDeleteByArticleIDCounter) < 1 {
		if m.DeleteByArticleIDMock.defaultExpectation.params == nil {
			m.t.Error("Expected call to ArticleTagRepositoryMock.DeleteByArticleID")
		} else {
			m.t.Errorf("Expected call to ArticleTagRepositoryMock.DeleteByArticleID with params: %#v", *m.DeleteByArticleIDMock.defaultExpectation.params)
		}
	}
	// if func was set then invocations count should be greater than zero
	if m.funcDeleteByArticleID != nil && mm_atomic.LoadUint64(&m.afterDeleteByArticleIDCounter) < 1 {
		m.t.Error("Expected call to ArticleTagRepositoryMock.DeleteByArticleID")
	}
}

// MinimockFinish checks that all mocked methods have been called the expected number of times
func (m *ArticleTagRepositoryMock) MinimockFinish() {
	if !m.minimockDone() {
		m.MinimockAddInspect()

		m.MinimockDeleteInspect()

		m.MinimockDeleteByArticleIDInspect()
		m.t.FailNow()
	}
}

// MinimockWait waits for all mocked methods to be called the expected number of times
func (m *ArticleTagRepositoryMock) MinimockWait(timeout mm_time.Duration) {
	timeoutCh := mm_time.After(timeout)
	for {
		if m.minimockDone() {
			return
		}
		select {
		case <-timeoutCh:
			m.MinimockFinish()
			return
		case <-mm_time.After(10 * mm_time.Millisecond):
		}
	}
}

func (m *ArticleTagRepositoryMock) minimockDone() bool {
	done := true
	return done &&
		m.MinimockAddDone() &&
		m.MinimockDeleteDone() &&
		m.MinimockDeleteByArticleIDDone()
}
